#ifndef SYSTEMCONTROL_H_
#define SYSTEMCONTROL_H_

#include "QueryInfo.h"
#include "CGI_Engine.h"
#include "UserMemberData.h"
#include "TextData.h"
#include "ConvertXML.h"

#define SEM_LOCK_SYSCONTROL			SEM_LOCK_ID + 14

class SystemControl : public CGI_Engine{
public:
	SystemControl(QueryInfo *query);
	~SystemControl();

protected:
	std::string	getHTMLFileName(std::string pageName, std::string command);
	std::string	getMapData(std::string keyName);
	bool		readDataFile();
	bool		loopProc(std::string loopKey);

private:
	std::map <std::string, std::string> curData;
	TextDataFile	*textData;
	std::string		folderKey;
	std::string		dataFile;
};


class SortData
{
public:
	SortData() : key(""), sort_key(0) {}
	SortData(const char* s, const unsigned long l) : key(s), sort_key(l) {}

public:
	std::string	key;
	double sort_key;

public:
	bool operator< (const SortData& d) const { return sort_key < d.sort_key; }
	bool operator> (const SortData& d) const { return sort_key > d.sort_key; }
};

#endif /*SYSTEMCONTROL_H_*/
