// -*- C++ -*-
/*!
 * @file  TerminalControl.cpp
 * @brief RSXXX Terminal Controller
 * @date $Date$
 *
 * $Id$
 */

#include "TerminalControl.h"

#include "Tools.h"
#include "AliveLib.h"

// Module specification
// <rtc-template block="module_spec">
static const char* terminalcontrol_spec[] =
  {
    "implementation_id", "TerminalControl",
    "type_name",         "TerminalControl",
    "description",       "RSXXX Terminal Controller ",
    "version",           "1.0.0",
    "vendor",            "RTC-Center",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "0",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
TerminalControl::TerminalControl(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
TerminalControl::~TerminalControl()
{
}



RTC::ReturnCode_t TerminalControl::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers

  // Set OutPort buffer

  // Set service provider to Ports

  // Set service consumers to Ports

  // Set CORBA Service Ports

  // </rtc-template>

	aliveLibInit(m_pManager, this);
	systemStateData.createData();

  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t TerminalControl::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TerminalControl::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TerminalControl::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t TerminalControl::onActivated(RTC::UniqueId ec_id)
{
	aliveLibActivated();

  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t TerminalControl::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t TerminalControl::onExecute(RTC::UniqueId ec_id)
{
	aliveLibIsAlive();

  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t TerminalControl::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TerminalControl::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TerminalControl::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TerminalControl::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TerminalControl::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{

  void TerminalControlInit(RTC::Manager* manager)
  {
    coil::Properties profile(terminalcontrol_spec);
    manager->registerFactory(profile,
                             RTC::Create<TerminalControl>,
                             RTC::Delete<TerminalControl>);
  }

};


