#ifndef _USER_MEMBER_DATA_H
#define _USER_MEMBER_DATA_H

// 標準インクルード
#include <time.h>
#include <stdio.h>
#include <string>
#include <vector>
#include <map>

//#define	VISIT_DATA_FOLDER	"/home/yotubata/workspace/TerminalSystem/TerminalServer/VisitHistory/"
#define	VISIT_DATA_FOLDER	"/home/yotubata/workspace/TerminalServer/VisitHistory/"
#define	VISIT_TICKET_NUMBER	"IV_VT_"
class VisitorTicket{
public:
	VisitorTicket();
private:
	struct RecordData{
		char	lpszNumber[32];		// チケット番号
		char	lpszName[32];		// 訪問者名
		char	lpszCompany[64];	// 訪問者会社名
		char	lpszPIC[32];		// 訪問先
		char	lpszServed[32];		// 応対者名
		char	lpszPurpose[16];	// 訪問理由
		time_t	visitTime;			// 訪問日時
		time_t	exitTime;			// 退館日時
	};
public:
	std::string	m_VisitNumber;		// チケット番号
	std::string	m_Name;				// 来訪者代表名
	std::string	m_Company;			// 来訪者所属
	std::string	m_PersonInCharge;	// 担当者名
	std::string	m_ServedName;		// 応対者名
	std::string	m_Purpose;			// 訪問理由
	int			m_Allowing;			// 受付状況
	bool		m_Closed;			// チケット処理済みフラグ
	time_t		m_VisitTime;		// 訪問日時
	time_t		m_ExitTime;			// 退館日時
	std::vector<short>	m_ServiceList;	// 提供サービスリスト

public:
	bool			readData(const std::string TicketName);
	unsigned int	writeData(const unsigned int number);
	bool			writeLog();
};

#define MEMBER_INFO_MAP	std::map< std::string, Data>
#define MEMBER_INFO_VAL	MEMBER_INFO_MAP::value_type
#define MEMBER_INFO_IT		MEMBER_INFO_MAP::iterator

class MemberInfo{
private:
	struct Data{
		std::string	m_Name;
		std::string	m_Kana;
		std::string	m_ShortName;
		std::string	m_ShortKana;
		std::string	m_MailAddr;
		bool		m_Default;
		bool		m_Available;
	};

public:
	int		readData(std::string dataFileName = "");
	bool	setAvailable(std::string mail_addr, bool available);
	MemberInfo::Data operator[](std::string name)	/*{ return m_List[name]; }*/;
	MemberInfo::Data	GetFrontDeskPIC()			{ return m_List[m_FrontDeskPIC]; }
	std::vector<std::string>	GetAvailableList();
	std::string					GetNameFromMailAddr(std::string mailAddr);
private:
	MemberInfo::Data	findMember(std::string mail_addr);
	MemberInfo::Data	findMemberFromKana(std::string kana);

private:
	std::string			m_FrontDeskPIC;
	MEMBER_INFO_MAP		m_List;
};

#endif
