/*
 * Tools.cpp
 *
 *  Created on: 2010/12/03
 *      Author: yotubata
 */
#include <fstream>
#include <stdlib.h>
#include <sstream>
#include <strstream>
#include <stdio.h>
#include <memory.h>
#include <iostream>
#include <regex.h>
#include <math.h>

#include "Tools.h"

/**
 * @brief 文字列を指定された区切り文字で分解し、分解したデータを返す
 * @return 分解された文字列のリスト
 */
std::vector<std::string> string_token(const std::string line, const char* tok)
{
	char *token, *str;
	char	data[1024];
	std::string	key_word;
	std::vector<std::string> ret;

	memset(data, 0, sizeof(data));
	strcpy(data, line.c_str());
	str = data;
	while(1){
		token = strtok(str, tok);
		if(token == 0)	break;
		key_word = token;
		ret.push_back(key_word);
		str = 0;
	}
	return ret;
}

std::string int_to_string(const int val)
{

	std::stringstream ss;

	ss << val;
	return ss.str();
}

int	string_to_int(const std::string str)
{
	char	*endPos;
	int	valType = 10;
	int	result;
	std::string	val = str;
//	std::istrstream ss(val.data());

	if(val.length() > 2){
		if(val[0] == '0'){
			if((val[1] == 'x') || (val[1] == 'X')){
				valType = 16;
				val = val.substr(2);
			}
		}
	}

//	std::cout << "0x : " << val << " / " << val.data() << std::endl;
#if 0
	{
		std::istrstream ss(val.data());
		switch(valType){
		case 16:
			ss >> std::hex >> result;
			break;
		default:
		case 10:
			ss >> std::dec >> result;
			break;
		}
	}
#else
	result = strtoul(val.c_str(), &endPos, valType);
#endif
//	printf("00xx : %x\n", result);

	return result;
}

std::string GetDateTimeStr(time_t *dateTime)
{
	std::string	result;
	size_t		timeStrLen;
	char		timeStr[24];

	if(dateTime != NULL)
		timeStrLen = strftime(timeStr, sizeof(timeStr), "%Y/%m/%d %H:%M:%S", localtime(dateTime));
	else{
		time_t pCurTime, curTime;

		curTime		= time(&pCurTime);
		timeStrLen	= strftime(timeStr, sizeof(timeStr), "%Y/%m/%d %H:%M:%S", localtime(&curTime));
	}
	result = timeStr;

	return result;
}

std::string GetTimeStr(time_t *dateTime)
{
	std::string	result;
	size_t		timeStrLen;
	char		timeStr[24];

	if(dateTime != NULL)
		timeStrLen = strftime(timeStr, sizeof(timeStr), "%H:%M:%S", localtime(dateTime));
	else{
		time_t pCurTime, curTime;

		curTime		= time(&pCurTime);
		timeStrLen	= strftime(timeStr, sizeof(timeStr), "%H:%M:%S", localtime(&curTime));
	}
	result = timeStr;

	return result;
}
std::string GetDateStr(time_t *dateTime)
{
	std::string	result;
	size_t		timeStrLen;
	char		timeStr[24];

	if(dateTime != NULL)
		timeStrLen = strftime(timeStr, sizeof(timeStr), "%Y/%m/%d", localtime(dateTime));
	else{
		time_t pCurTime, curTime;

		curTime		= time(&pCurTime);
		timeStrLen	= strftime(timeStr, sizeof(timeStr), "%Y/%m/%d", localtime(&curTime));
	}
	result = timeStr;

	return result;
}



std::string GetDateTimeNum(time_t *dateTime)
{
	std::string	result;
	size_t		timeStrLen;
	char		timeStr[24];

	if(dateTime != NULL)
		timeStrLen = strftime(timeStr, sizeof(timeStr), "%Y%m%d%H%M%S", localtime(dateTime));
	else{
		time_t pCurTime, curTime;

		curTime		= time(&pCurTime);
		timeStrLen	= strftime(timeStr, sizeof(timeStr), "%Y%m%d%H%M%S", localtime(&curTime));
	}
	result = timeStr;

	return result;
}

unsigned long DateStrToULong(const std::string datetimeStr)
{
	std::vector< std::string >		datetimeList;
	unsigned long	result = 0;

	if(isDateString(datetimeStr)){
		datetimeList = string_token(datetimeStr, "/.");
		result = result + string_to_int(datetimeList[0]) * 10000;
		result = result + string_to_int(datetimeList[1]) * 100;
		result = result + string_to_int(datetimeList[2]) * 1;
	}
	return result;
}

double DatetimeStrToDouble(const std::string dateStr, const std::string timeStr)
{
	double			factor = 0.01;
	double 			result = 0;
	std::string		datetimeStr;
	std::vector< std::string >	data;

	datetimeStr = dateStr + " ";
	datetimeStr = datetimeStr + timeStr;
	data = string_token(datetimeStr, "./: ");
	for(; data.size() > 0; data.pop_back()){
		result = result + string_to_int(data[data.size()-1]) * factor;
		factor = factor * 100;
	}

	return result;
}

std::string DateULongToString(const unsigned long datetimeVal)
{
	std::string	result = "";
	unsigned long	val = datetimeVal;

	if (datetimeVal > 1800*1000){
		result = result + int_to_string(val / 10000);
		val = val % 10000;
		result = result + int_to_string(val / 100);
		val = val % 100;
		result = result + int_to_string(val);
	}

	return result;
}

bool isDateString(const std::string val)
{
	bool		result = false;
#if 0
	regex_t		reg;
	regmatch_t	match;

	// 正規表現の種(パターン)を準備する
	if(regcomp(&reg, "\\d{2,4}/\\d{1,2}/\\d{1,2}", REG_ICASE | REG_EXTENDED | REG_NEWLINE) != 0) {
		std::cout << "パターン構築失敗" << std::endl;
	}
	// パターンマッチングを行う
	if(regexec(&reg, val.c_str(), 1, &match, 0) == 0) {
		// 必要な文字列を取り出す
		result = true;
	}

	// 種を開放する
	regfree(&reg);
#else
	std::vector< std::string >	dateVal;
	dateVal = string_token(val, "/.");
	if(dateVal.size() == 3)
		result = true;
#endif
	return result;
}


off_t fMove(const int fd, const off_t src, const off_t dest)
{
	off_t	result = 0;
	char	buff[1024]/*, backupBuff[1024]*/;
	int		readLen, writeLen, moveLen, buffLen;
	off_t	backupPos, writePos, readPos;

	if(src == dest)
		return -1;

	if(src > dest){
		readPos = src;
		writePos = dest;
		readLen = sizeof(buff);
		while(readLen == sizeof(buff)){
			lseek(fd, readPos, SEEK_SET);
			readLen = read(fd, buff, sizeof(buff));
			readPos = lseek(fd, 0, SEEK_CUR);
			lseek(fd, writePos, SEEK_SET);
			writeLen = write(fd, buff, readLen);
			writePos = lseek(fd, 0, SEEK_CUR);
			if(writeLen != readLen){
				result = -1;
				break;
			}
		}
		result = writePos;
//		ftruncate(fd, writePos);
	}
	else{
		// 最後尾のデータから順に移動していく
		moveLen = dest - src;
		backupPos = lseek(fd, 0, SEEK_END);
		buffLen = 1024;
		writePos = backupPos + (dest - src);
		while(buffLen == 1024){
			backupPos = backupPos - 1024;
			if(backupPos < src){
				buffLen = (backupPos + 1024) - src;
				backupPos = src;
			}
			backupPos = lseek(fd, backupPos, SEEK_SET);
			read(fd, buff, buffLen);
			lseek(fd, writePos, SEEK_SET);
			write(fd, buff, buffLen);
			writePos = writePos + buffLen;
		}
		lseek(fd, 0, SEEK_END);
	}

	return true;
}
